package cn.com.tenlion.systembase.service.enterprisepatrol;

import cn.com.tenlion.systembase.pojo.bos.enterprisepatrol.EnterprisePatrolBO;
import cn.com.tenlion.systembase.pojo.dtos.enterprisepatrol.EnterprisePatrolDTO;
import cn.com.tenlion.systembase.pojo.pos.enterprisepatrol.EnterprisePatrolPO;
import cn.com.tenlion.systembase.pojo.vos.enterprisepatrol.EnterprisePatrolVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IEnterprisePatrolService
 * @Description: 企业巡查记录
 * @Author: CodeFactory
 * @Date: 2022-01-07 15:23:28
 * @Version: 3.0
 **/
public interface IEnterprisePatrolService {

    /**
     * 新增企业巡查记录
     *
     * @param enterprisePatrolVO
     * @return
     */
    void save(EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 新增企业巡查记录
     *
     * @param token
     * @param enterprisePatrolVO
     * @return
     */
    void save(String token, EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 新增企业巡查记录
     *
     * @param enterprisePatrolVO
     * @return enterprisePatrolId
     */
    String saveReturnId(EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 新增企业巡查记录
     *
     * @param token
     * @param enterprisePatrolVO
     * @return enterprisePatrolId
     */
    String saveReturnId(String token, EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 删除企业巡查记录
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除企业巡查记录
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除企业巡查记录（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改企业巡查记录
     *
     * @param enterprisePatrolId
     * @param enterprisePatrolVO
     * @return
     */
    void update(String enterprisePatrolId, EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 修改企业巡查记录
     *
     * @param token
     * @param enterprisePatrolId
     * @param enterprisePatrolVO
     * @return
     */
    void update(String token, String enterprisePatrolId, EnterprisePatrolVO enterprisePatrolVO);

    /**
     * 企业巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    EnterprisePatrolDTO get(Map<String, Object> params);

    /**
     * 企业巡查记录详情
     *
     * @param enterprisePatrolId
     * @return
     */
    EnterprisePatrolDTO get(String enterprisePatrolId);

    /**
     * 企业巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    EnterprisePatrolBO getBO(Map<String, Object> params);

    /**
     * 企业巡查记录详情
     *
     * @param enterprisePatrolId
     * @return
     */
    EnterprisePatrolBO getBO(String enterprisePatrolId);

    /**
     * 企业巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    EnterprisePatrolPO getPO(Map<String, Object> params);

    /**
     * 企业巡查记录详情
     *
     * @param enterprisePatrolId
     * @return
     */
    EnterprisePatrolPO getPO(String enterprisePatrolId);

    /**
     * 企业巡查记录列表
     *
     * @param params
     * @return
     */
    List<EnterprisePatrolDTO> list(Map<String, Object> params);

    /**
     * 企业巡查记录列表
     *
     * @param params
     * @return
     */
    List<EnterprisePatrolBO> listBO(Map<String, Object> params);

    /**
     * 企业巡查记录列表
     *
     * @param params
     * @return
     */
    List<EnterprisePatrolPO> listPO(Map<String, Object> params);

    /**
     * 企业巡查记录分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<EnterprisePatrolDTO>> listPage(ListPage page);

    /**
     * 企业巡查记录统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}